//*****************************************************************************
//* FILE NAME:       DiagMsg.h
//* FILE CONTAINS:
//* DESCRIPTION:     .
//* NOTES:           .
//*****************************************************************************
//*                   INTEL CORPORATION PROPRIETARY INFORMATION
//*     This software is supplied under the terms of a license agreement or
//*     nondisclosure agreement with Intel Corporation and may not be copied
//*     or disclosed except in accordance with the terms of that agreement.
//*           Copyright (c) 1995 Intel Corporation.  All Rights Reserved.
//*****************************************************************************

#ifndef D_DiagMsg_HeaderFile
#define D_DiagMsg_HeaderFile

#include "CompDiag.h"

#ifdef D_CompilerDiagnostics
   #pragma D_CompDiagMsg("\"D_CompilerDiagnostics\" defined")
#endif

#ifdef D_CompilerDiagnostics
   #pragma D_CompDiagMsg("Include")
#endif

//*****************************************************************************
//* INCLUDEs
//*****************************************************************************

//-----------------------------------------------------------------------------
// System Includes
//-----------------------------------------------------------------------------

#ifdef D_CompilerDiagnostics
   #pragma D_CompDiagMsg("#include <windef.h>")
#endif

#include <windef.h>

#include "DebugPrint.h"          
#include "DiagCodes.h"


#if DBG

   #ifdef D_CompilerDiagnostics
      #pragma D_CompDiagMsg("Checked build")
   #endif

   #define D_BuildType  "Checked"

#endif

#if DEBUGPRINT

   #ifdef D_CompilerDiagnostics
      #pragma D_CompDiagMsg("Free build")
   #endif

   #define D_BuildType  "Free"

#endif

#if DBG || DEBUGPRINT                     // Kernel Mode?

   #ifdef D_CompilerDiagnostics
      #pragma D_CompDiagMsg("Debug print enabled for kernel mode")
   #endif

   #define D_DiagPrint     DbgPrint

   #define D_KernelMode    TRUE

#else                                     // User Mode

   #ifdef D_CompilerDiagnostics
      #pragma D_CompDiagMsg("Diagnostic message enabled for user mode")
   #endif

   #define D_KernelMode    FALSE          // I.e. User Mode

   #define D_DiagPrint     printf

#endif

//-----------------------------------------------------------------------------

#if DBG

   #ifdef D_CompilerDiagnostics
      #pragma D_CompDiagMsg("Diagnostic messages being defined")
   #endif
	#define DRIVER_NAME			"IMBDrv"

   #define D_DiagMsg(DbgCode)                                       \
        {                                                           \
            if (gulDbgCode & DbgCode)                            \
                D_DiagPrint(DRIVER_NAME"(%s,%d):\n",__FILE__,__LINE__);  \
        }                                                           \

   #define D_DiagMsg0(DbgCode,ArgFmt)                                           \
        {                                                               \
            if (gulDbgCode & DbgCode)                            \
	            D_DiagPrint(DRIVER_NAME"(%s,%d): "ArgFmt".\n",__FILE__,__LINE__);\
        }                                                               \

   #define D_DiagMsg1(DbgCode,ArgFmt,Arg1)                             \
        {                                                                       \
            if (gulDbgCode & DbgCode)                            \
	            D_DiagPrint(DRIVER_NAME"(%s,%d): "ArgFmt".\n",__FILE__,__LINE__,Arg1);   \
        }                                                                       \

   #define D_DiagMsg2(DbgCode,ArgFmt,Arg1,Arg2)                            \
        {                                                                           \
            if (gulDbgCode & DbgCode)                            \
	            D_DiagPrint(DRIVER_NAME"(%s,%d): "ArgFmt".\n",__FILE__,__LINE__,Arg1,Arg2);  \
        }                                                                           \

   #define D_DiagMsg3(DbgCode,ArgFmt,Arg1,Arg2,Arg3)                           \
        {                                                                               \
            if (gulDbgCode & DbgCode)                            \
	            D_DiagPrint(DRIVER_NAME"(%s,%d): "ArgFmt".\n",__FILE__,__LINE__,Arg1,Arg2,Arg3); \
        }                                                                               \

   #define D_DiagMsg4(DbgCode,ArgFmt,Arg1,Arg2,Arg3,Arg4)                           \
        {                                                                               \
            if (gulDbgCode & DbgCode)                            \
                D_DiagPrint(DRIVER_NAME"(%s,%d): "ArgFmt".\n",__FILE__,__LINE__,Arg1,Arg2,Arg3,Arg4); \
        }                                                                               \

    #define D_DbgDumpData(DbgCode,str,array,len)                    \
        {                                                   \
            if (gulDbgCode & DbgCode)                            \
	            DbgDumpData(DRIVER_NAME": "str" : ",array,len);      \
        }                                                   \

    #define D_DbgPrintIrp(DbgCode,pirp)                             \
        {                                                   \
            if (gulDbgCode & DbgCode)                            \
			{												\
                D_DiagMsg(DbgCode);                                    \
    	        DbgPrintIrp(pirp);                              \
	        }                                                   \
		}
#else

   #ifdef D_CompilerDiagnostics
      #pragma D_CompDiagMsg("Diagnostic messages not defined")
   #endif

   #define D_DiagMsg(DiagCode)

   #define D_DiagMsg0(DbgCode,ArgFmt)

   #define D_DiagMsg1(DbgCode,ArgFmt,Arg1)

   #define D_DiagMsg2(DbgCode,ArgFmt,Arg1,Arg2)

   #define D_DiagMsg3(DbgCode,ArgFmt,Arg1,Arg2,Arg3)

   #define D_DiagMsg4(DbgCode,ArgFmt,Arg1,Arg2,Arg3,Arg4)

   #define D_DbgDumpData(DbgCode,str,array,len)

   #define D_DbgPrintIrp(DbgCode,pirp)
        
#endif

//-----------------------------------------------------------------------------

#endif
