//*****************************************************************************
//* FILE NAME:       IMBDrvWMI.c
//* FILE CONTAINS:
//* DESCRIPTION:     Win 2000 WMI support.
//* NOTES:           This file is used for Win 2000 only.
//*****************************************************************************
//*                   INTEL CORPORATION PROPRIETARY INFORMATION
//*     This software is supplied under the terms of a license agreement or
//*     nondisclosure agreement with Intel Corporation and may not be copied
//*     or disclosed except in accordance with the terms of that agreement.
//*           Copyright (c) 1995 Intel Corporation.  All Rights Reserved.
//*****************************************************************************

//*****************************************************************************
//* INCLUDES
//*****************************************************************************

//-----------------------------------------------------------------------------
// Local Includes
//-----------------------------------------------------------------------------

#include "CompDiag.h"
#include "w2k_drv.h"
#include "w2k_wmi.h"
#include "DiagMsg.h"
#include "IMBDrvWMI.h"

//*****************************************************************************
//* FUNCTIONS
//*****************************************************************************

//=============================================================================
// (...)
//-----------------------------------------------------------------------------
// 
// HRESULT DeviceIoControl(   DWORD          dwIoControlCode, 
//                            LPVOID         lpInBuffer, 
//                            DWORD          nInBufferSize, 
//                            LPVOID         lpOutBuffer, 
//                            DWORD          nOutBufferSize, 
//                            LPDWORD        lpBytesReturned, 
//                            LPOVERLAPPED   lpOverlapped
//                            );
//=============================================================================

NTSTATUS gtDeviceIoControl(struct S_WMI_MethodArg *asp_WMI_MethodArg)
  {
   struct _ID_MOF_C_mvDeviceIoControl_Args *sp_ID_MOF_C_mvDeviceIoControl_Args
      = (struct _ID_MOF_C_mvDeviceIoControl_Args *)asp_WMI_MethodArg->ucpBuffer;

   D_DiagMsg0( D_Win2000LowLevelInfo,
               "WMI execute method \"gtDeviceIoControl(...)\""
               );

   D_DiagMsg2( D_Win2000LowLevelInfo,
               "\"dwIoControlCode\" = %u, \"InBufferSize\" = %u",
               sp_ID_MOF_C_mvDeviceIoControl_Args->u32_dwIoControlCode,
               sp_ID_MOF_C_mvDeviceIoControl_Args->u32_dwInBufferSize
               );

   D_DiagMsg2( D_Win2000LowLevelInfo,
               "\"dwIoControlCode\" = %u, \"dwIoControlCode\" = %u",
               sp_ID_MOF_C_mvDeviceIoControl_Args->u32_dwOutBufferSize,
               sp_ID_MOF_C_mvDeviceIoControl_Args->u64_lpBytesReturned
               );

   return (STATUS_SUCCESS);
   }
