
/*M*                     
//                    INTEL CORPORATION PROPRIETARY INFORMATION
//      This software is supplied under the terms of a license agreement or
//      nondisclosure agreement with Intel Corporation and may not be copied
//      or disclosed except in accordance with the terms of that agreement.
//            Copyright (c) 1995 Intel Corporation.  All Rights Reserved.
//
*M*/
/*
 * $Log:   //epg-scc/sst/ProjectDatabases/WMI_PI/archives/ISM6_1/Source/imbdrv/memmap.c.v  $
 * 
 *    Rev 1.0   Apr 22 2003 11:14:46   jabays
 * Initial revision.
 * 
 *    Rev 1.1.2.4   Apr 04 2003 13:29:26   cjgill
 * CHecking in changes with comments from Sundar at IIDC.
 * 
 *    Rev 1.1.2.2   23 Feb 2001 15:42:06   mrajmohx
 * Code changes for compliance with Windows XP 2428 DDK.
 * 
 *    Rev 1.1.2.1   Aug 08 2000 09:33:32   ajayamox
 * This file is NO longer used in compilation process.
 * 
 *    Rev 1.1.2.0   May 23 2000 10:25:00   ajayamox
 * Win64 Related Changes. size_t and typecast problems related to porting of Win32 code has been corrected.
 *
 *    Rev 1.1   08 Dec 1998 10:55:48   jpaiasno
 * Added code to support async.
 * DPC events from the EMP console.
 * 
 *    Rev 1.2   24 Mar 1998 14:40:54   fkhanx
 * Added copyright header
*/

#ifndef UWSVR4

#include "imb_os.h"
#include "memIf.h"
/////////////////////////////////////////////////////////////////////////////////////////////////

/*F*
//  Name:       MapTheMemory
//  Purpose:    Given a physical address range, maps it into a user mode process's
//                          address space
.
//  Context:    Called by map memory IOCTL  processing Mismic  device control function.
//  Returns:    STATUS_SUCCESS or STATUS_UNSUCCESSFUL
//  Parameters:
//                              DeviceObject            Pointer to device object        
//              IoBuffer                Pointer to bus number storage location
//                              InputBufferLength       length of input buffer 
//              OutputBufferLength  output buffer length. size of the mapped address pointer.
//  Notes:      
*F*/
#if 0
NTSTATUS
MapTheMemory (
    IN PDEVICE_OBJECT DeviceObject,
    IN OUT PVOID      IoBuffer,
    IN ULONG          InputBufferLength,
    IN ULONG          OutputBufferLength
    )
{

    PPHYSICAL_MEMORY_INFO ppmi = (PPHYSICAL_MEMORY_INFO) IoBuffer;

    INTERFACE_TYPE     interfaceType;
    ULONG              busNumber;
    PHYSICAL_ADDRESS   physicalAddress;
    ULONG              length;
    UNICODE_STRING     physicalMemoryUnicodeString;
    OBJECT_ATTRIBUTES  objectAttributes;
    HANDLE             physicalMemoryHandle  = NULL;
    PVOID              PhysicalMemorySection = NULL;
    ULONG              inIoSpace, inIoSpace2;
    NTSTATUS           ntStatus;
    PHYSICAL_ADDRESS   physicalAddressBase;
    PHYSICAL_ADDRESS   physicalAddressEnd;
    PHYSICAL_ADDRESS   viewBase;
    PHYSICAL_ADDRESS   mappedLength;
    BOOLEAN            translateBaseAddress;
    BOOLEAN            translateEndAddress;
    PVOID              virtualAddress1;
		PULONG_PTR		   virtualAddress;

  
		D_DiagMsg0(D_HighLevelInfo,"Inside The Map Memory \n");

    if ( ( InputBufferLength  < sizeof (PHYSICAL_MEMORY_INFO) ) ||
		 ( OutputBufferLength < sizeof (PVOID) ) )      {
      

       ntStatus = STATUS_INSUFFICIENT_RESOURCES;

       goto done;
    }

		
		D_DiagMsg0(D_HighLevelInfo,"After the parameter validation \n");
    interfaceType          = ppmi->InterfaceType;
    busNumber              = ppmi->BusNumber;
    physicalAddress        = ppmi->BusAddress;
    inIoSpace = inIoSpace2 = ppmi->AddressSpace;
    length                 = ppmi->Length;

    //
    // Get a pointer to physical memory...
    //
    // - Create the name
    // - Initialize the data to find the object
    // - Open a handle to the oject and check the status
    // - Get a pointer to the object
    // - Free the handle
    //
    RtlInitUnicodeString (&physicalMemoryUnicodeString,
			  L"\\Device\\PhysicalMemory");

    InitializeObjectAttributes (&objectAttributes,
				&physicalMemoryUnicodeString,
				OBJ_CASE_INSENSITIVE,
				(HANDLE) NULL,
				(PSECURITY_DESCRIPTOR) NULL);

    ntStatus = ZwOpenSection (&physicalMemoryHandle,
			      SECTION_ALL_ACCESS,
			      &objectAttributes);

    if ( !NT_SUCCESS(ntStatus) )  {
		goto done;
    }

		D_DiagMsg0(D_HighLevelInfo,"After the Open Section\n");

    ntStatus = ObReferenceObjectByHandle (physicalMemoryHandle,
					  SECTION_ALL_ACCESS,
					  (POBJECT_TYPE) NULL,
					  KernelMode,
					  &PhysicalMemorySection,
					  (POBJECT_HANDLE_INFORMATION) NULL);

    if ( !NT_SUCCESS(ntStatus) )  {
		goto close_handle;
    }


		D_DiagMsg0(D_HighLevelInfo,"After Obj Ref by Handle \n");
    //
    // Initialize the physical addresses that will be translated
    //
    physicalAddressEnd = RtlLargeIntegerAdd (physicalAddress,
							 RtlConvertUlongToLargeInteger(
							 length));
    //
    // Translate the physical addresses.
    //
    translateBaseAddress = HalTranslateBusAddress (interfaceType,
								busNumber,
								physicalAddress,
								&inIoSpace,
								&physicalAddressBase );

    translateEndAddress = HalTranslateBusAddress (interfaceType,
								busNumber,
								physicalAddressEnd,
								&inIoSpace2,
								&physicalAddressEnd );

    if ( !(translateBaseAddress && translateEndAddress) ) {
		ntStatus = STATUS_UNSUCCESSFUL;

		goto close_handle;
    }

		D_DiagMsg0(D_HighLevelInfo,"After HalTranslateBusAddress \n");
    //
    // Calculate the length of the memory to be mapped
    //
    mappedLength = RtlLargeIntegerSubtract ( physicalAddressEnd, physicalAddressBase );

    //
    // If the mappedlength is zero, somthing  weird happened in the HAL
    // since the Length was checked against zero.
    //
    if ( mappedLength.LowPart == 0 ) {
		ntStatus = STATUS_UNSUCCESSFUL;

		goto close_handle;
    }


		D_DiagMsg0(D_HighLevelInfo,"After RtlLargeIntegerSubtract\n");
    length = mappedLength.LowPart;

    //
    // If the address is in io space, just return the address, otherwise
    // go through the mapping mechanism
    //
    if ( inIoSpace ) {
        *((PVOID *) IoBuffer) = (PVOID) (ULONG_PTR) physicalAddressBase.LowPart;
    } else {
		//
		// initialize view base that will receive the physical mapped
		// address after the MapViewOfSection call.
		//
		viewBase = physicalAddressBase;

		//
		// Let ZwMapViewOfSection pick an address
		//
		virtualAddress1 = NULL;

		//
		// Map the section
		//
		ntStatus = ZwMapViewOfSection ( physicalMemoryHandle,
						   /*(HANDLE) -1,NtCurrentProcess()*/
							 NtCurrentProcess(),
						   (PVOID *) &virtualAddress1,
						   0L,
						   length,
						   &viewBase,
						   (PSIZE_T )&length,
						   ViewShare,
						   0,
						   PAGE_READWRITE | PAGE_NOCACHE);

		if ( !NT_SUCCESS(ntStatus) ) {
			D_DiagMsg1(D_HighLevelInfo,"Error in ZwMapViewOfSection, %x \n", ntStatus);
			goto close_handle;
		}


		D_DiagMsg0(D_HighLevelInfo,"After ZwMapViewOfSection\n");
		//
		// Mapping the section above rounded the physical address down to the
		// nearest 64 K boundary. Now return a virtual address that sits where
		// we want by adding in the offset from the beginning of the section.
		//
		virtualAddress = (PULONG_PTR)virtualAddress1;
		(PUCHAR)virtualAddress	+= ((ULONG_PTR)physicalAddressBase.LowPart - (ULONG_PTR)viewBase.LowPart);

		*((PVOID *) IoBuffer)	 = (PVOID) virtualAddress;
    }
    ntStatus = STATUS_SUCCESS;

close_handle:

    ZwClose (physicalMemoryHandle);

done:


		D_DiagMsg0(D_HighLevelInfo,"Exit Mapping Memory \n");

    return ntStatus;
}
#endif

#if 1

//Structure to store the virtual memory information
//The information like UserVirtualAddress, SystemVirtualAddress
//and MDL have to be stored in the array when the Map IOCTL is 
//called. These information is required
//to free these resource during the UnMap IOCTL call since user appication
//will only know about UserVirtualAddress for mapping and unmapping the region.

#pragma pack(1)
typedef struct 
{
	PVOID UserVirtualAddress; 
	PVOID SystemVirtualAddress;
	PMDL  Mdl;
	ULONG length; 
} MEM_INFO, * PMEM_INFO;
#pragma pack()

//Maximum number of elements in the list
//This implies the user appication can map maximum
//10 regions with out unmapping them. The appication 
//has to unmap the mapped region using UnMap IOCTL at the end
//otherwise Map IOCTL will be failed.

#define MEM_INFO_MAX_NUM 			10
MEM_INFO MemInfo[MEM_INFO_MAX_NUM];

/////////////////////////////////////////////////////////////////////////////////////////////////
//  Name:       AddMemInfo 
//  Purpose:    Functions to Add the virtual memory info in the array. 
//  Context:    Called from MapTheMemory
//  Returns:    FALSE, if there is no space in the array,
//  		else TRUE
//  Parameters: user, User Virtual Address
//  		System, System Virtual Address
//  		MDL, Pointer to MDL
//  		length, length of the mapped memory 
/////////////////////////////////////////////////////////////////////////////////////////////////
BOOL AddMemInfo ( PVOID user, PVOID System, PMDL Mdl , ULONG length)
{
	int i;			
	for (i=0; i < MEM_INFO_MAX_NUM; i++)
	{
		if (MemInfo[i].UserVirtualAddress == NULL)
		{
			MemInfo[i].UserVirtualAddress = user;
			MemInfo[i].SystemVirtualAddress = System;
			MemInfo[i].Mdl = Mdl;	
			MemInfo[i].length = length;

			return TRUE;
		}
	}			

	return FALSE;
}
/////////////////////////////////////////////////////////////////////////////////////////////////
//  Name:       UnmapTheMemory
//  Purpose:    Unmpa the mapped virtual address
//  Context:    Called by Unmap memory IOCTL  processing 
//  Returns:    STATUS_SUCCESS or STATUS_UNSUCCESSFUL
//  Parameters: IoBuffer, Pointer to User Virtual Address location
/////////////////////////////////////////////////////////////////////////////////////////////////
NTSTATUS UnmapTheMemory ( IN PVOID	IoBuffer)
{
	ULONGLONG UserVirtualAddress = *((ULONGLONG *) IoBuffer);
	int i;			
	
	for (i=0; i < MEM_INFO_MAX_NUM; i++)
	{
		if (MemInfo[i].UserVirtualAddress == (PVOID)UserVirtualAddress)
		{
			MmUnmapIoSpace(MemInfo[i].SystemVirtualAddress, 
											MemInfo[i].length); 
			MmUnmapLockedPages((PVOID)UserVirtualAddress, MemInfo[i].Mdl);
			IoFreeMdl(MemInfo[i].Mdl); 

			MemInfo[i].UserVirtualAddress = NULL;

			return STATUS_SUCCESS;
		}
	}

	return STATUS_UNSUCCESSFUL;
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//  Name:       MapTheMemory
//  Purpose:    Given a physical address range, maps it into a user mode process's
//              address space
//  Context:    Called by map memory IOCTL  processing 
//  Returns:    STATUS_SUCCESS or STATUS_UNSUCCESSFUL
//  Parameters: DeviceObject            Pointer to device object        
//              IoBuffer                Pointer to bus number storage location
//              InputBufferLength       length of input buffer 
//              OutputBufferLength  		output buffer length. size of the mapped address pointer.
//  Notes:      Dont use ZwMapViewOfSection for mapping the memory. When it is called more than
//  						once in a single process context, it is failed. Use MmMapIoSpace to map the 
//  						memory. This issue only arrises in 64 bit platform.
/////////////////////////////////////////////////////////////////////////////////////////////////

NTSTATUS
MapTheMemory (
    IN PDEVICE_OBJECT DeviceObject,
    IN OUT PVOID      IoBuffer,
    IN ULONG          InputBufferLength,
    IN ULONG          OutputBufferLength
    )
{

    PPHYSICAL_MEMORY_INFO ppmi = (PPHYSICAL_MEMORY_INFO) IoBuffer;

    INTERFACE_TYPE     interfaceType;
    ULONG              busNumber;
    PHYSICAL_ADDRESS   physicalAddress;
    ULONG              length;
    UNICODE_STRING     physicalMemoryUnicodeString;
    OBJECT_ATTRIBUTES  objectAttributes;
    HANDLE             physicalMemoryHandle  = NULL;
    PVOID              PhysicalMemorySection = NULL;
    ULONG              inIoSpace, inIoSpace2;
    NTSTATUS           ntStatus;
    PHYSICAL_ADDRESS   physicalAddressBase;
    PHYSICAL_ADDRESS   physicalAddressEnd;
    PHYSICAL_ADDRESS   viewBase;
    PHYSICAL_ADDRESS   mappedLength;
    BOOLEAN            translateBaseAddress;
    BOOLEAN            translateEndAddress;
    PVOID              SystemVirtualAddress;
		PVOID							 UserVirtualAddress;
		PULONG_PTR		   virtualAddress;

  	PMDL  							Mdl;

    if ( ( InputBufferLength  < sizeof (PHYSICAL_MEMORY_INFO) ) ||
		 ( OutputBufferLength < sizeof (PVOID) ) )      {
      
       return  STATUS_INSUFFICIENT_RESOURCES;
    }

    interfaceType          = ppmi->InterfaceType;
    busNumber              = ppmi->BusNumber;
    physicalAddress        = ppmi->BusAddress;
    inIoSpace = inIoSpace2 = ppmi->AddressSpace;
    length                 = ppmi->Length;

    // Initialize the physical addresses that will be translated
    //
    physicalAddressEnd = RtlLargeIntegerAdd (physicalAddress,
							 RtlConvertUlongToLargeInteger(
							 length));
    
		// Translate the physical addresses.
    translateBaseAddress = HalTranslateBusAddress (interfaceType,
								busNumber,
								physicalAddress,
								&inIoSpace,
								&physicalAddressBase );

    translateEndAddress = HalTranslateBusAddress (interfaceType,
								busNumber,
								physicalAddressEnd,
								&inIoSpace2,
								&physicalAddressEnd );

    if ( !(translateBaseAddress && translateEndAddress) )
		{
			return STATUS_UNSUCCESSFUL;
    }

    // Calculate the length of the memory to be mapped
    mappedLength = RtlLargeIntegerSubtract ( physicalAddressEnd, physicalAddressBase );

    //
    // If the mappedlength is zero, somthing  weird happened in the HAL
    // since the Length was checked against zero.
    //
    if ( mappedLength.LowPart == 0 ) 
		{
			return STATUS_UNSUCCESSFUL;
    }


    length = mappedLength.LowPart;

    //
    // If the address is in io space, just return the address, otherwise
    // go through the mapping mechanism
    //
		//
		// initialize view base that will receive the physical mapped
		// address after the MapViewOfSection call.
		//
		if ( inIoSpace ) 
		{
        *((PVOID *) IoBuffer) = (PVOID) (ULONG_PTR) physicalAddressBase.LowPart;
    } 
		else 
		{
				SystemVirtualAddress = MmMapIoSpace(physicalAddressBase, length, MmNonCached); 

				if (SystemVirtualAddress == NULL)
				{
					return STATUS_UNSUCCESSFUL;
				}

				Mdl = IoAllocateMdl(SystemVirtualAddress, length, FALSE, FALSE, NULL); 

				if (Mdl == NULL)
				{
					MmUnmapIoSpace(SystemVirtualAddress, length); 
					return STATUS_UNSUCCESSFUL;
				}
						
				MmBuildMdlForNonPagedPool(Mdl); 

				UserVirtualAddress = MmMapLockedPagesSpecifyCache 
							(Mdl, UserMode, MmCached, NULL, FALSE, NormalPagePriority);
				if (AddMemInfo (UserVirtualAddress, SystemVirtualAddress, Mdl, length) == FALSE )
				{
					MmUnmapIoSpace(SystemVirtualAddress, length); 
					MmUnmapLockedPages(UserVirtualAddress, Mdl);
					IoFreeMdl(Mdl); 
					return STATUS_UNSUCCESSFUL;
				}
				*((PVOID *) IoBuffer)	 = (PVOID) UserVirtualAddress;
		}
    
		return STATUS_SUCCESS;

}
#endif

#endif // UWSVR4
